<template>
    <q-dialog class="home">
        <q-card class="border-radius-50 q-pa-sm" style="width: 335px">
            <q-card-section class="row items-center row justify-center" >
                <!-- Title -->
                <div class="col-12 items-center row justify-left"  >
                    <span
                        class="font-16 text-center helvetica-neue-medium"
                        no-caps
                        v-if="state.type == 'view'"
                    >
                        Branches
                    </span>
                    <span
                        class="font-16 text-center helvetica-neue-medium"
                        no-caps
                        v-else
                    >
                        Assign Branches
                    </span>
                    <q-space />
                    <q-btn icon="close" flat round dense v-close-popup />

                </div>
                <!-- Search Bar -->
                <div class="col-12 q-mt-sm">
                    <q-option-group
                    v-if="state.type == 'view'"
                    :options="state.options"
                    type="checkbox"
                    class="col-12"
                    left-label
                    disable
                    v-model="state.group"
                    />
                    <q-option-group
                    v-else
                    :options="state.options"
                    type="checkbox"
                    class="col-12"
                    left-label
                    v-model="state.group"
                    @click="submitChanges"
                    />
                </div>
                <div class="col-12 col-md-3 col-lg-12 row justify-center items-center q-mt-md" v-if="state.type =='add'">
                <q-btn
                    no-caps
                    text-color="white"
                    class="
                        button-assign
                        float-right
                        helvetica-neue-medium
                    "
                    @click="changeBranch"
                    :label="$t('button.save')"
                />
            </div>
            </q-card-section>
        </q-card>
    </q-dialog>
</template>

<style scoped>
.q-checkbox {
    justify-content: space-between;
}
</style>

<script lang="ts">
import {
    defineComponent,
    ref,
    reactive,
    watch,
    computed,
    onMounted
} from 'vue';
import { useStore } from 'src/store';
import { TabType } from 'src/services/enums/TabType';

export default defineComponent({
    name: 'BranchSelection',
    props: {
        type: {
            type: String,
            required: true
        },
        memberInfo: {
            type: Object,
            required: true
        }
    },
    setup(props, { emit }) {
        const store = useStore();
        const search = ref('');
        const conversationState = store.state.conversation;

        const selectedBusinessId = computed(() => {
            return store.state.business.businessID;
        });


        let state = reactive({
            loadingState: ref(false),
            group: ref([]),
            searchResults: ref(false),
            searchList: [] as any,
            selectedLabel: [] as any,
            labels: [] as any,
            options: [] as any,
            branches: computed(() => { return store.state.branch.branches; }),
            business: computed(() => { return store.state.business.businesses; }),
            memberInfo: props.memberInfo as any,
            type: props.type as any,
        });

        const initBranch = () => {
            state.branches.forEach((element : any) => {
                state.options.push({ label: element.name, value: element.id })
            });

            let branchIds = [] as any
             state.memberInfo.branches.forEach((element : any)=>{
                 branchIds.push(element.id)
            })
            state.group = (branchIds)

        };

         const changeBranch = async () => {
            await store.dispatch('member/update', {
                memberId: state.memberInfo.id,
                branchIds: state.group
            });
            emit('update-branch', 'true');
        };

        onMounted(initBranch)

        return {
            state,
            search,
            dense: ref(true),
            TabType,
            changeBranch
        };
    }
});
</script>
